import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:video_player/video_player.dart';

class BasicOverlayWidget extends StatelessWidget {
  final VideoPlayerController controller;

  const BasicOverlayWidget({
    Key key,
    @required this.controller,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) => GestureDetector(
        behavior: HitTestBehavior.opaque,
        onTap: () => {
          if (controller.value.isPlaying == false)
            {controller.seekTo(Duration(seconds: 0)), controller.play()}
          else
            {controller.pause()}
          // controller.value.isPlaying ? controller.pause() : controller.play()
        },
        child: Stack(
          children: <Widget>[
            buildPlay(),
            Positioned(
              bottom: 0,
              left: 0,
              right: 0,
              child: buildIndicator(),
            ),
          ],
        ),
      );

  Widget buildIndicator() => VideoProgressIndicator(
        controller,
        allowScrubbing: true,
        colors: VideoProgressColors(playedColor: Color(0xFF083356)),
      );

  Widget buildPlay() => controller.value.isPlaying
      ? Container()
      : Container(
          alignment: Alignment.center,
          color: Colors.black26,
          height: ScreenUtil().setHeight(145),
          child: Icon(Icons.play_arrow, color: Colors.white, size: 80),
        );
}
